#ifndef LIBREGEXIS024_FA_FIRST_STAGE_FIX_H
#define LIBREGEXIS024_FA_FIRST_STAGE_FIX_H

#include "finite_automaton.h"

namespace regexis024 {
    struct REGEX_IS024_FA_FirstStageFixInfo{
        bool fed_chars_extend_one_left = false;
        bool fed_chars_extend_one_right = false;
    };

    /* Will look for look_one_ahead nodes and apply their filter to reading filters ahead *
     * sourceFa will be ruined. The output will be in resultFa */
    REGEX_IS024_FA_FirstStageFixInfo first_stage_fix_fa(FA_Container& sourceFa, FA_Container& resultFa);

    void regular_second_stage_fix(const FA_Container& sourceFa, FA_Container& resultFa,
        const REGEX_IS024_FA_FirstStageFixInfo &info1);
}

#endif //LIBREGEXIS024_FA_FIRST_STAGE_FIX_H
