#ifndef LIBREGEXIS024_SRC_LIBREGEXIS024FA_WRITING_COMMANDS_H
#define LIBREGEXIS024_SRC_LIBREGEXIS024FA_WRITING_COMMANDS_H

#include <libregexis024fa/graph_to_bytecode/natural_compiler_utils.h>
#include <libregexis024vm/vm_opcodes.h>

namespace regexis024 {
    void cmd_JUMP(std::vector<uint8_t>& result, explicit_bookmarks& bookmark_manager, bookmark_id_t dest);

    void cmd_JCEQUAL(std::vector<uint8_t>& result, explicit_bookmarks& bookmark_manager, uint64_t val, bookmark_id_t dest);
    void cmd_JCLESS(std::vector<uint8_t>& result, explicit_bookmarks& bookmark_manager, uint64_t val, bookmark_id_t dest);
    void cmd_JCGRTR(std::vector<uint8_t>& result, explicit_bookmarks& bookmark_manager, uint64_t val, bookmark_id_t dest);

    void cmd_DIE(std::vector<uint8_t>& result);
    void cmd_MATCH(std::vector<uint8_t>& result);

    void cmd_READ(std::vector<uint8_t>& result, size_t slot);
    void cmd_FORK(std::vector<uint8_t> &result, explicit_bookmarks& bookmark_manager, size_t slot, bookmark_id_t dest);
}

#endif
