#ifndef LIBREGEXIS024_SRC_LIBREGEXIS024FA_SELARR_PRIORITY_TABLE_H
#define LIBREGEXIS024_SRC_LIBREGEXIS024FA_SELARR_PRIORITY_TABLE_H

#include <stdint.h>
#include <vector>
#include <libregexis024fa/tracking_variables.h>

namespace regexis024 {
    struct RegexPriorityTableAction_Pos{
        /* first and second are indexes in selarr (but second can be -1 if it is unused) */
        int first;
        int second;
        tracking_var_type_t type;
        bool isForRange() const;

        RegexPriorityTableAction_Pos(int first, int second, tracking_var_type_t type);
    };

    struct RegexPriorityTableAction{
        bool minimize;
        RegexPriorityTableAction_Pos pos;
        RegexPriorityTableAction(bool minimize, int first, int second, tracking_var_type_t type);
    };

    typedef std::vector<RegexPriorityTableAction> RegexPriorityTable;
}

#endif //LIBREGEXIS024_SRC_LIBREGEXIS024FA_SELARR_PRIORITY_TABLE_H
