#ifndef LIBREGEXIS024_SRC_LIBREGEXIS024FA_TRACKING_VARIABLES_H
#define LIBREGEXIS024_SRC_LIBREGEXIS024FA_TRACKING_VARIABLES_H

#include <map>
#include <string>

namespace regexis024 {
    namespace tracking_var_types {
        enum tracking_var_type_I {
            range,
            dot_cur_pos,
            dot_immediate
        };
    }

    typedef tracking_var_types::tracking_var_type_I tracking_var_type_t;

    struct TrackingVariableInfo {
        bool stored_in_ca = true;
        bool stored_in_sa = false;

        tracking_var_type_t type;
        /* These fields will be -1 if unused */
        int colarr_first = -1;
        int colarr_second = -1;

        int selarr_first = -1;
        int selarr_second = -1;
    };

    typedef std::map<std::string, TrackingVariableInfo> track_var_list;
}

#endif
