#include <libregexis024sol/common_codesets.h>

namespace regexis024 {
    CommonCodesets::CommonCodesets() {
        spaces = set_add_char(spaces, U'\n');
        spaces = set_add_char(spaces, U' ');
        spaces = set_add_char(spaces, U'\t');
        spaces = set_add_char(spaces, U'\r');
        word_constituents = set_add_range(word_constituents, U'a', U'z');
        word_constituents = set_add_range(word_constituents, U'A', U'Z');
        digits = codeset_t({{'0', '9'}});
        variable_constituents = set_add_char(word_constituents, U'-');
        variable_constituents = merge_sets(variable_constituents, digits);
    }
}
