#include <libregexis024vm/vm_opcodes.h>

namespace regexis024 {
    const char *opcode_to_str(opcode_t x) {
        switch (x) {
#define rcase(name) case opcodes::name: return #name;
            rcase(READ)
            rcase(READZ)
            rcase(JUMP)
            rcase(JCEQUAL_B)
            rcase(JCEQUAL_W)
            rcase(JCEQUAL_DW)
            rcase(JCEQUAL_QW)
            rcase(JCLESS_B)
            rcase(JCLESS_W)
            rcase(JCLESS_DW)
            rcase(JCLESS_QW)
            rcase(JCGRTR_B)
            rcase(JCGRTR_W)
            rcase(JCGRTR_DW)
            rcase(JCGRTR_QW)
            rcase(FORK)
            rcase(MATCH)
            rcase(DIE)
            rcase(PARAM_READ_SS_NUMBER)
            rcase(PARAM_FORK_SS_NUMBER)
            rcase(PARAM_SELARR_LEN)
            rcase(PARAM_COLSIFTFUNC_SET)
            rcase(PARAM_COLSIFTFUNC_WIPE)
            rcase(DMOV_RABX_SELARR)
            rcase(DDIST_RABX_SELARR)
            rcase(SIFTPRIOR_MIN_RABX)
            rcase(SIFTPRIOR_MAX_RABX)
            rcase(SIFT_DONE)
            rcase(MOV_COLARR_IMM)
            rcase(MOV_COLARR_BTPOS)
            rcase(MOV_SELARR_IMM)
            rcase(MOV_SELARR_CHPOS)
            rcase(INIT)
            rcase(THROW)
            default:
                return "Invalid opcode";
        }
    }
}
