#include <libregexis024vm/libregexis024vm.h>
#include <libregexis024vm/vm_opcodes.h>

namespace regexis024 {
    bool check_inboundness(VMContext& ctx, int region){
        return vmprog_check_inboundness(ctx.program_size, ctx.active_thread.IP, region);
    }

    uint8_t extract_b(VMContext& ctx) {
        return vmprog_extract_b(&ctx.active_thread.IP, ctx.prg);
    }

    uint16_t extract_w(VMContext& ctx) {
        return vmprog_extract_w(&ctx.active_thread.IP, ctx.prg);
    }

    uint32_t extract_dw(VMContext& ctx) {
        return vmprog_extract_dw(&ctx.active_thread.IP, ctx.prg);
    }

    uint64_t extract_qw(VMContext& ctx) {
        return vmprog_extract_qw(&ctx.active_thread.IP, ctx.prg);
    }

    uint8_t extract_instruction(VMContext& ctx) {
        return extract_b(ctx);
    }

    sslot_id_t extract_sslot_id(VMContext& ctx) {
        return extract_dw(ctx);
    }

    near_ptr_t extract_near_pointer(VMContext& ctx) {
        return extract_qw(ctx);
    }

    tai_t extract_track_array_index(VMContext& ctx) {
        return extract_w(ctx);
    }
}
