#include <libregexis024vm/vm_opcodes.h>

namespace regexis024 {
    bool vmprog_check_inboundness(near_ptr_t prgSz, near_ptr_t IP, near_ptr_t region) {
        return IP + region <= prgSz;
    }

    uint8_t vmprog_extract_b(near_ptr_t *IPptr, const uint8_t *prg) {
        return prg[(*IPptr)++];
    }

    uint16_t vmprog_extract_w(near_ptr_t *IPptr, const uint8_t *prg) {
        uint16_t answer = 0;
        (*IPptr) += 2;
        for (int i = 1; i < 3; i++) {
            answer <<= 8; answer |= prg[(*IPptr) - i];
        }
        return answer;
    }

    uint32_t vmprog_extract_dw(near_ptr_t *IPptr, const uint8_t *prg) {
        uint32_t answer = 0;
        (*IPptr) += 4;
        for (int i = 1; i < 5; i++) {
            answer <<= 8; answer |= prg[(*IPptr) - i];
        }
        return answer;
    }

    uint64_t vmprog_extract_qw(near_ptr_t *IPptr, const uint8_t *prg) {
        uint64_t answer = 0;
        (*IPptr) += 8;
        for (int i = 1; i < 9; i++) {
            answer <<= 8; answer |= prg[(*IPptr) - i];
        }
        return answer;
    }

    uint8_t vmprog_extract_instruction(near_ptr_t *IPptr, const uint8_t *prg) {
        return vmprog_extract_b(IPptr, prg);
    }

    sslot_id_t vmprog_extract_sslot_id(near_ptr_t *IPptr, const uint8_t *prg) {
        return vmprog_extract_dw(IPptr, prg);
    }

    near_ptr_t vmprog_extract_near_pointer(near_ptr_t *IPptr, const uint8_t *prg) {
        return vmprog_extract_qw(IPptr, prg);
    }

    tai_t vmprog_extrack_track_array_index(near_ptr_t *IPptr, const uint8_t *prg) {
        return vmprog_extract_w(IPptr, prg);
    }
}
